/******************************************************************************

襭 ⥬  ࠨ᪨ ࠢ ()
⮤ ᪮३襣 ᪠
 ᯮ짮 ன ࠭ଠ樨      v. 4.0

(c) 2002 ⠭᫠               <xstazz@hotbox.ru>

ணࠬ ࠡ             http://vt.spbgmtu.ru

******************************************************************************/


#include <math.h>
#include <conio.h>
#include "matrix6.cpp"


//ଠ
double norma(TMatrix<double> &x)
{
   double res=0;
   int m=x.getSizeRow(), n=x.getSizeCol();

   for(int i=1; i<=m; i++)
   {
      for(int j=1; j<=n; j++)
      {
	 res+=x(i,j)*x(i,j);
      }
   }

   return sqrt(res);
}


//襭  ⮤ ᪮३襣 ᪠
TMatrix<double> linearSolveFastDescent(TMatrix<double> &a,// .
				       TMatrix<double> &b,//ࠢ 
				       double sigma,   //譮
				       long max_step) //. - 蠣
{
   int n=a.getSizeRow();
   TMatrix<double> x(b), a_tr(a.getTranspose()), r(n,1), s(n,1);

   for(long k=0; k<max_step; k++)
   {
      r=b-a*x;
      s=a_tr*r;
      x+=(r%r)/(s%s)*s;

      if(norma(r)<sigma)
      {
	 break;
      }
   }

   cout<<"᫮ 蠣: "<<k<<endl;

   if(k==max_step)
   {
      cout<<" 筮  ⨣"<<endl;
   }

   return x;
}


void main(void)
{
  char ch;
  TMatrix<double> a_b;
  double sigma=.0000001;
  long max_step=10000;

  cout.setf(ios::showpoint);

  for(;;)
  {
     clrscr();
     cout<<"襭 ⥬  ࠨ᪨ ࠢ"<<endl
	<<"⮤ ᪮३襣 ᪠"<<endl<<endl
	<<"1   -    䠩"<<endl
	<<"2   -  譮 ᫥"<<endl
	<<"3   -  ᨬ쭮 - 蠣"<<endl
	<<"4   -  "<<endl<<endl
	<<"Esc - 室"<<endl<<endl<<endl;

     do
     {
	ch=getch();
     }
     while(ch!='1' && ch!='2' && ch!='3' && ch!='4' && ch!=27);

     switch(ch)
     {
	case '1':
	{
	    clrscr();
	    char str[20];
	    cout<<"  䠩:"<<endl;
	    cin>>str;
	    ifstream in_file(str);
	    if(in_file)
	    {
	       int n;
	       in_file>>n;
	       a_b.setSize(n,n+1);
	       a_b.readArray(in_file);
	       a_b.writeArray(cout);
	    }
	    else
	    {
	       cout<<"   䠩 \""<<str<<"\""<<endl;
	    }
	    getch();
	    break;
	}
	case '2':
	{
	    clrscr();
	    cout<<" 譮 ᫥ ("<<sigma<<"): ";
	    cin>>sigma;
	    break;
	}
	case '3':
	{
	    clrscr();
	    cout<<" ᨬ쭮 - 蠣 ("<<max_step<<"): ";
	    cin>>max_step;
	    break;
	}
	case '4':
	{
	    TMatrix<double> x;
	    clrscr();
	    cout<<"襭 "<<endl;
	    cout<<"७  ⥬:"<<endl;
	    a_b.writeArray(cout);
	    cout<<"譮: "<<sigma<<endl;
	    cout<<"ᨬ쭮 - 蠣: "<<max_step<<endl;

	    int n=a_b.getSizeRow();
	    TMatrix<double> a(a_b.getPart(1,1,n,n)), b(a_b.getCol(n+1));
	    x=linearSolveFastDescent(a,b,sigma,max_step);

	    cout<<"襭: "<<endl;
	    x.writeArray(cout);

	    ofstream out_file("result.txt");
	    if(out_file)
	    {
	       out_file<<"襭 "<<endl;
	       out_file<<"७  ⥬:"<<endl;
	       a_b.writeArray(out_file);
	       out_file<<"譮: "<<sigma<<endl;
	       out_file<<"ᨬ쭮 - 蠣: "<<max_step<<endl;
	       out_file<<"襭: "<<endl;
	       x.writeArray(out_file);
	    }
	    else
	    {
	       cout<<"  ᮧ 䠩 \"result.txt\""<<endl;
	    }

	    getch();
	    break;
	}
	case 27:
	{
	   return;
	}
     }
  }
}


